import java.io.*;
import hpjava.*;

public class HPJ {
  static final int N      = 9;
  static final int NITER  = 50;
  static final String [] hosts = {"koum", "naos", "koum", "naos"};
  static final int NNODE = hosts.length;
  static DataInputStream[] fromNode;

  public static void main(String args[]) {
    Initialize("HPJW");
    CollectResult();
  }

  static void Initialize(String name) {
    int i, j;
    Port[][] port = new Port[NNODE][NNODE];
    fromNode = new DataInputStream[NNODE];
    for (i=1; i<NNODE; i++) 
    for (j=0; j<i; j++) {
      port[i][j] = new Port();
      port[j][i] = new Port();
      Port.channel(port[i][j], port[j][i]);
    }
    for (i=0; i<NNODE; i++) {
      Port U = new Port() ;
      Port V = new Port() ;
      Port.channel(U, V) ;
      RPC.spawn(name, hosts [i], V) ;
      U.sendInt(NNODE) ;
      U.sendInt(i) ;
      for (j=0; j<NNODE; j++)
        if (j != i) U.sendChan(port[j][i]);
      U.sendInt(N) ;
      U.sendInt(NITER) ;
      fromNode[i] = new DataInputStream(new PortInputStream(U));
      System.out.println("OK");
    }
  }

  static void CollectResult() {
    try {
      int i, j;
      for (i=0; i<NNODE; i++) {
        System.out.println("Processor No."+i);
        int xseg = fromNode[i].readInt();
        int yseg = fromNode[i].readInt();
        for (int y=0; y<yseg; y++) {
          for (int x=0; x<xseg; x++)
            System.out.print(fromNode[i].readInt()+" ");
          System.out.println();
        }
      }
    } catch ( Exception e ) {
      System.out.println("I/O Error!");
    }
  }
}

